'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.imageuploadBrowserByUrl = exports.imageView = exports.imageScan = undefined;

var _yylibUi = require('yylib-ui');

var _ajax = require('yylib-utils/ajax');
var Cookies = require('js-cookie');
var multiLang = require('./1056.json');


var util = {};
//封装简易的Ajax
!function (util) {
    var vanillaAjax = {
        get: function get(url, fn) {
            var xhr = new XMLHttpRequest(); // XMLHttpRequest对象用于在后台与服务器交换数据
            xhr.open('GET', url, true);
            xhr.onreadystatechange = function () {
                if (xhr.readyState == 4 && xhr.status == 200 || xhr.status == 304) {
                    // readyState == 4说明请求已完成
                    fn.call(this, xhr.responseText); //从服务器获得数据
                }
            };
            xhr.send();
        },
        post: function post(url, data, fn) {
            // datat应为'a=a1&b=b1'这种字符串格式，在jq里如果data为对象会自动将对象转成这种字符串格式
            var xhr = new XMLHttpRequest();
            xhr.open("POST", url, true);
            xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded"); // 添加http头，发送信息至服务器时内容编码类型
            xhr.onreadystatechange = function () {
                if (xhr.readyState == 4 && (xhr.status == 200 || xhr.status == 304)) {
                    // 304未修改
                    fn.call(this, JSON.parse(xhr.responseText));
                }
            };
            if (!data) {
                data = {};
            }
            xhr.send(data);
        }
    };
    util.ajax = vanillaAjax;
}(util);

//jsonp组件
!function (util) {
    var jsonp = function jsonp(url, opts, fn) {
        if ('function' == typeof opts) {
            fn = opts;
            opts = {};
        }
        if (!opts) opts = {};

        var prefix = opts.prefix || '__jp';
        var count = 0;
        // use the callback name that was passed if one was provided.
        // otherwise generate a unique name by incrementing our counter.
        var id = opts.name || prefix + count++;

        var param = opts.param || 'callback';
        var timeout = null != opts.timeout ? opts.timeout : 60000;
        var enc = encodeURIComponent;
        var target = document.getElementsByTagName('script')[0] || document.head;
        var script;
        var timer;

        if (timeout) {
            timer = setTimeout(function () {
                cleanup();
                if (fn) fn(new Error('Timeout'));
            }, timeout);
        }

        function cleanup() {
            if (script.parentNode) script.parentNode.removeChild(script);
            window[id] = null;
            if (timer) clearTimeout(timer);
        }

        function cancel() {
            if (window[id]) {
                cleanup();
            }
        }

        window[id] = function (data) {
            cleanup();
            if (fn) fn(null, data);
        };

        // add qs component
        url += (~url.indexOf('?') ? '&' : '?') + param + '=' + enc(id);
        url = url.replace('?&', '?');

        // create script
        script = document.createElement('script');
        script.src = url;
        target.parentNode.insertBefore(script, target);

        return cancel;
    };
    util.jsonp = jsonp;
}(util);

//appendHtml 组件
!function (util) {
    var appendHTML = function appendHTML(el, htmlStr) {
        var tempDiv = document.createElement('div');
        var fragment = document.createDocumentFragment();
        tempDiv.innerHTML = htmlStr;
        var nodes = tempDiv.childNodes;
        for (var i = 0, length = nodes.length; i < length; i++) {
            fragment.appendChild(nodes[i].cloneNode(true));
        }
        el.appendChild(fragment);
    };
    util.appendHTML = appendHTML;
}(util);

var w = 1440;
var h = 900;
var l = 1440;
var t = 900;

/**
 * 影像扫描
 * @param params
 */
function imageScan(params) {
    var data = params.data,
        checkscanway = params.checkscanway;

    if (!data) return;
    var param = {};
    var dataJson = JSON.stringify(data);
    var compressType = '';
    var compression = false;

    param.bill = dataJson;
    param.compressType = compressType;
    param.compression = compression;
    param.checkscanway = checkscanway;
    ajax({
        url: window.EnvConfig.ADDR + '/nccloud/web/image/SSCImageUploadAction.do?time=' + new Date().getTime(),
        data: param,
        success: function success(data) {
            if (data.data.success == "true") {
                var factoryCode = data.data.factoryCode;
                var ipAddr = data.data.ipaddr;
                var paraStr = '';
                if (factoryCode == "tchzt2") {
                    paraStr = data.data.parastr;
                } else {
                    paraStr = data.data.parastr;
                }
                imageuploadBrowserByUrl(factoryCode, ipAddr, paraStr);
            } else {
                _yylibUi.YYMessage.error(data['error']['message']);
            }
        }
    });
}

function imageuploadBrowserByUrl(factoryCode, ipAddr, paraStr) {
    if (factoryCode == "tchzt2") {
        return openTBrowser(paraStr);
    } else {
        var dataJson = JSON.parse(paraStr);

        if (dataJson.url_opensoft == null || dataJson.url_opensoft == undefined || dataJson.url_opensoft == "") {
            alert(multiLang['1056image-0035']);
            return;
        }
        window.open(dataJson.url_opensoft);
    }
}

/**
 * 影像查看
 */
function imageView(params) {
    var data = params.data,
        permission = params.permission;

    if (!data) {
        return;
    }

    var param = {};
    var dataJson = JSON.stringify(data);
    var compressType = '';
    var compression = false;
    param.bill = dataJson; //此处必须编码，否则接口报decode fail.错误
    param.compressType = compressType;
    param.compression = compression;
    ajax({
        url: window.EnvConfig.ADDR + '/nccloud/web/image/SSCImageShowAction.do?time=' + new Date().getTime(),
        data: param,
        success: function success(data) {
            if (data.data.success == "true") {
                var ipAddr = data.data.ipaddr;
                if (!ipAddr || Object.keys(ipAddr).length === 0) {
                    return;
                }
                var paraStr = encodeURI(encodeURI(data.data.parastr));
                var factoryCode = data.data.factoryCode;
                imageshowBrowserByUrl(factoryCode, ipAddr, paraStr);
            } else {
                _yylibUi.YYMessage.error(data['error']["message"]);
            }
        }
    });
}

function imageshowBrowserByUrl(factoryCode, ipAddr, paraStr) {
    if (window.opener == null) {
        window.imageBrowserWin = window.open(paraStr, multiLang['1056image-0039'], "width=" + w + ",height=" + h + ",left=" + l + ",top=" + t + ",toolbar=no, menubar=no, scrollbars=no, resizable=yes, location=no, status=no");
    } else {
        window.imageBrowserWin = window.opener.open(paraStr, multiLang['1056image-0039'], "width=" + w + ",height=" + h + ",left=" + l + ",top=" + t + ",toolbar=no, menubar=no, scrollbars=no, resizable=yes, location=no, status=no");
    }
}

var protocol_name = "TURLProtocol:";

function openTBrowser(dataStr) {
    if (dataStr.indexOf("{") > -1 && dataStr.indexOf("}") > -1) {
        var data = eval('(' + dataStr + ')');
        if (data.url_opensoft == null || data.url_opensoft == undefined || data.url_opensoft == "") {
            alert(multiLang['1056image-0035']);
            return;
        }

        if (data.url_opensoft.indexOf(protocol_name) > -1) {
            var uuid = data.uuid;
            var finalurl = data.url_opensoft;
            util.appendHTML(document.body, '<iframe billid="image_iframe" style="display:none;" src="' + finalurl + '"></iframe>');

            var param = {};
            param.uuid = uuid;
            window.setTimeout(function () {
                window.onbeforeunload = null;
                ajax({
                    url: '/nccloud/web/image/SSCCheckOpenStatusAction.do?time=' + new Date().getTime(),
                    data: param,
                    success: function success(response) {
                        if (response.data == "N") {
                            window.open(data.url_download, "Download", "height=400, width=800, top=100, left=100, toolba=no, menubar=no, scrollbars=no, resizable=no, location=no, status=no");
                        }
                    }
                });
            }, data.time * 1000);
        }
    } else {
        window.open(dataStr, multiLang['1056image-0039'], "toolbar=no, menubar=no, scrollbars=no, resizable=yes, location=no, status=no");
    }
};

function ajax(request) {
    if (!request) return;
    var url = request.url,
        data = request.data,
        success = request.success,
        error = request.error;
    var params = {
        busiParamJson: JSON.stringify(data),
        sysParamJson: { pagecs: Cookies.get("cookiets") }
    };
    _ajax.postJSONWithCookies(url, params, function (result) {
        if (result.success) {
            success && success(result);
        } else {
            error && error(result);
        }
    });
}

/**
 * imageScan 影像扫描
 * imageView 影像查看
 */
exports.imageScan = imageScan;
exports.imageView = imageView;
exports.imageuploadBrowserByUrl = imageuploadBrowserByUrl;